/////////////////////////////////////////////////////////////////////////////
// HelloWorld.cpp defines plugin loading/unloading and execution

#include "stdafx.h"
#include <afxdllx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Include the QckPlugin API header file

#include "qckplugin.h"

/////////////////////////////////////////////////////////////////////////////
// QCKPLUGIN API
// Define InitQckPlugin to be called when the plugin is loaded/initialized

int InitQckPlugin(const char* path, void* handle, void* manager)
{

// Obtain the pointer to the plugin service manager

  IQckSrvcMgr* mgr = (IQckSrvcMgr*)manager;

// Register this plugin with the menu service

  IQckMenuSrvc* menu = mgr->RegisterForMenuItemService();
  if(menu) {

// Add the menu item for the plugin

	  menu->CreateMenuItem(handle, "Hello World!");
  }

  return 0;
}

/////////////////////////////////////////////////////////////////////////////
// QCKPLUGIN API
// Define ExecuteQckPlugin to be called when a plugin menu item is selected

void ExecuteQckPlugin(int argc, void* argv)
{
  AfxMessageBox("Hello World!", MB_ICONINFORMATION);
}

/////////////////////////////////////////////////////////////////////////////
// QCKPLUGIN API
// Define CloseQckPlugin to be called when the plugin is unloaded/closeed

void CloseQckPlugin()
{
}

/////////////////////////////////////////////////////////////////////////////
// AppWizard generated content

static AFX_EXTENSION_MODULE HelloWorldDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("HELLOWORLD.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(HelloWorldDLL, hInstance))
			return 0;

		new CDynLinkLibrary(HelloWorldDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("HELLOWORLD.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(HelloWorldDLL);
	}
	return 1;   // ok
}

/////////////////////////////////////////////////////////////////////////////